var Component = function(id) {
	this.id = id;
	this.obj = $('#' + id);

	this.fw = '.fw_';
};

Component.enable = function(obj, b) {
	if (b){
		obj.removeAttr('disabled'); 
	}
	else {
		obj.attr('disabled', 'disabled'); 
	}
};

var Interval = function(id) {
	if (arguments.length < 1) {
		return;
	}
	Component.apply(this, [ id ]);

	this.row = 'row';
	this.plus = 'plus';
	this.minus = 'minus';
};
Interval.prototype = new Component();

Interval.prototype.init = function() {
	var self = this;

	this.obj.find(this.fw + this.plus).click(function() {
		var src = self.obj.find(self.fw + self.row + ':last-child');
		var dst = src.clone(true);

		dst.appendTo(self.obj);
	});
	this.obj.find(this.fw + this.minus).click(function() {
		var src = self.obj.find(self.fw + self.row + ':last-child');

		src.remove();
	});
};

var Pulldown = function(id, id2) {
	if (arguments.length < 1) {
		return;
	}
	Component.apply(this, [ id ]);

	this.id2 = id2;
	this.obj2 = $('#' + id2);

	this.clone = '_clone';
};
Pulldown.prototype = new Component();

Pulldown.prototype.init = function() {
	var self = this;

	this.obj.change(function() {
		var val = $(this).val();
		var obj = self.obj;
		var obj2 = self.obj2;
		var obj3 = self.obj3;
		var fw = self.fw.substring(1);

		obj2.empty().append(obj3.clone().children());
		obj2.find('option').each(function() {
			if (!$(this).hasClass(fw + val)) {
				$(this).remove();
			}
		});

		Component.enable(obj2, val != obj.children(':first').val());
	});

	this.obj3 = $('<select id="' + this.fw + this.id + this.clone + '" />')
			.appendTo('body').hide().append(this.obj2.find('option').clone());
	
	this.obj.change();
}
